nickle (2.84-1) unstable; urgency=medium

  * Correct crash compiling implicit sized arrays with mismatching
    init dimensionality. Closes: #911926.
  * Fix SIGTSTP handling to work in more cases, including under dash
    and when run as other than the process group leader.
  * Ignore '_' in numeric values, permitting its use as a separator.

 -- Keith Packard <keithp@keithp.com>  Fri, 26 Oct 2018 13:36:57 -0700

nickle (2.83-1) unstable; urgency=medium

  * Include debian/source/format in tarball
  * Fix spelling errors in man page
  * Fix a pile of lintian warnings
  * Sign tarfiles when released
  * Run CI tests from installed location

 -- Keith Packard <keithp@keithp.com>  Mon, 22 Oct 2018 19:08:54 -0700

nickle (2.82-1) unstable; urgency=medium

  * Switch to mktime from timelocal for musl compatibility
  * Change exp to scale precision correctly. Fixes exp and log.

 -- Keith Packard <keithp@keithp.com>  Tue, 02 Oct 2018 20:57:31 -0700

nickle (2.81-1) unstable; urgency=low

  * Don't attempt to test Y2038 bug fix yet. It's not fixed on 32-bit
    machines.

 -- Keith Packard <keithp@keithp.com>  Tue, 14 Nov 2017 02:29:18 -0800

nickle (2.80-2) unstable; urgency=low

  * Update standard version to 4.1.1
  * Remove unnecessary configure overrides in rules
  * Remove use of autotools-dev

 -- Keith Packard <keithp@keithp.com>  Tue, 14 Nov 2017 01:54:20 -0800

nickle (2.80-1) unstable; urgency=medium

  * Support float values in JSON
  * Add JSON tests
  * Make nickle-tutorial.pdf build reproducibly
  * Add date conversion functions

 -- Keith Packard <keithp@keithp.com>  Mon, 13 Nov 2017 15:57:51 -0800

nickle (2.79-2) unstable; urgency=low

  * Update to standards 3.9.8
  * Switch to 3.0 (quilt) format
  * Update to dh version 10
  * Avoid installing COPYING files which duplicate copyright data
  * Make examples which are scripts executable

 -- Keith Packard <keithp@keithp.com>  Thu, 23 Mar 2017 07:45:52 +0100

nickle (2.79-1) unstable; urgency=low

  * Fix bus error on sparc64 due to unaligned DataCache.

 -- Keith Packard <keithp@keithp.com>  Thu, 16 Mar 2017 10:52:49 -0700

nickle (2.78-1) unstable; urgency=low

  * Add sudoku generator and solver example.
  * Fix write order of large queued data.
  * Add JSON input/output library.
  * Use release date in configure.in instead of `date`
  * Initialize 'replace' in NewTypedBox. (Closes: #857840, #857814, #857815)
  * Adapt test to new automake.

 -- Keith Packard <keithp@keithp.com>  Wed, 15 Mar 2017 09:35:37 -0700

nickle (2.77-1) unstable; urgency=low

  * Build tutorial when docbook2pdf is available
  * tutorial: Use sgml entities instead of < and >
  * Tutorial: twixt doesn't have an optional 'else' block
  * Rename nickle tutorial to nickle-tutorial
  * Corrected some Nickle Tour nits
  * Handle OpFarJump in CompileReachable

 -- Keith Packard <keithp@keithp.com>  Tue, 06 Nov 2012 11:04:49 -0800

nickle (2.76-1) unstable; urgency=low

  * Fix FTBS on Hurd-i386.
  * Don't crash when using initializer with forward ref type
  * Fix crashes when MemCollect occurs during Twixt execution

 -- Keith Packard <keithp@keithp.com>  Mon, 11 Jun 2012 13:29:18 -0700

nickle (2.75-1) unstable; urgency=low

  * Fix ref types in array pointer operations (&foo->bar)
  * Shorten value printing in stack traces
  * Switch to 'dh' for building package. Closes: #666356

 -- Keith Packard <keithp@keithp.com>  Fri, 30 Mar 2012 08:42:02 -0700

nickle (2.74-1) unstable; urgency=low

  * Fix Semaphore::wait to not deadlock
  * Switch debian package building to use pdebuild

 -- Keith Packard <keithp@keithp.com>  Sat, 03 Mar 2012 17:16:35 -0800

nickle (2.73-1) unstable; urgency=low

  * add gamma function
  * fix readline interaction when using pipes
  * add sort and skiplist to library
  * add is_type and has_member built-ins
  * typecheck switch statements

 -- Keith Packard <keithp@keithp.com>  Wed, 29 Feb 2012 17:00:25 +1300

nickle (2.72-1) unstable; urgency=low

  * wait3 returns 0 when there's nothing left to do
  * Rename configure.in to configure.ac
  * Block in select instead of sigsuspend when waiting for I/O
  * Keep readline from catching signals

 -- Keith Packard <keithp@keithp.com>  Sun, 29 Jan 2012 22:03:44 -0800

nickle (2.71-1) unstable; urgency=low

  * Update old-school variable length struct allocation to ansi-C
  * Replace most parameterized macros in nickle.h and value.h with
    static inline functions.
  * Clean up a pile of build warnings
  * Catch attempts to use uninitialized pointer contents
  * Exit after two consecutive interrupts
  * Cleanup struct type changes

 -- Keith Packard <keithp@keithp.com>  Fri, 25 Nov 2011 11:43:31 -0800

nickle (2.70-1) unstable; urgency=low

  * Make parse_csv_t type public
  * Throw 'bad_csv_parse' exception on unclosed quotes
  * Add factorial tests
  * Repliace naïve factorial algorithm with the prime swing
    algorithm defined by Peter Luschny
  * Update to standard 3.8.4

 -- Keith Packard <keithp@keithp.com>  Tue, 06 Jul 2010 01:22:30 -0400

nickle (2.69-1) unstable; urgency=low

  * Make debian build depend on libreadline-dev not libreadline5-dev.
  * Get math-tables.5c built before tests are run
  * Fix trig boundary conditions.
  * Add tests for math functions.
  * math.5c: fix quadrant errors in atan/asin/acos

 -- Keith Packard <keithp@keithp.com>  Thu, 17 Sep 2009 14:30:42 -0700

nickle (2.68-1) unstable; urgency=low

  * Add README.release
  * Bump debian standards to 3.8.0
  * Allow background nickle to not poll on tty ownership
  * Remove support for non-SIGIO pipes
  * Fix floating point printing to correctly round output

 -- Keith Packard <keithp@keithp.com>  Sat, 21 Jun 2008 02:17:49 -0700

nickle (2.67-1) unstable; urgency=low
  * Don't require string to be first param on builtin exceptions
  * Add io_eof exceptions when reading at EOF
  * Add unix-domain socket support
  * Make SIGINT raise signal exception
  * Add pid/uid/gid builtins
  * Add unlink/rename/mkdir/rmdir builtins
  * Autoimport works better on nested namespaces

 -- Keith Packard <keithp@keithp.com>  Wed, 19 Mar 2008 16:09:04 -0700

nickle (2.66-1) unstable; urgency=low
  * Support autoload/autoimport of nested namespaces.
  * Allow 'print' to find unpublished names

 -- Keith Packard <keithp@keithp.com>  Sun, 13 Jan 2008 17:39:49 -0800

nickle (2.65-1) unstable; urgency=low
  * Add new '+' type operator for subtyping struct/union
  * Eliminate segfault when pretty printing func declarations
  * Check for duplicate func param/struct member names

 -- Keith Packard <keithp@keithp.com>  Sun, 06 Jan 2008 16:38:51 -0800

nickle (2.64-1) unstable; urgency=low
  * Fix float floor/ceil with small values
  * Copy hash key/value on insert
  * Bump to version 2.64

 -- Keith Packard <keithp@keithp.com>  Fri, 04 Jan 2008 00:41:15 -0800

nickle (2.63-1) unstable; urgency=low
  * Avoid using extra libraries unless necessary
  * Fix -Wl,-E testing by using AC_LINK_IFELSE
  * Make foreign objects equal when they point at the same data
  * Bump to version 2.63

 -- Keith Packard <keithp@keithp.com>  Sat, 29 Dec 2007 16:02:57 -0800

nickle (2.62-1) unstable; urgency=low
  * Add modulus test case
  * Fix % and // operators to follow modulus rules
  * Update manual to fix // and % documentation
  * Bump to version 2.62

 -- Keith Packard <keithp@keithp.com>  Sun, 09 Dec 2007 21:14:27 -0800

nickle (2.61-1) unstable; urgency=low
  * Allow '.' before struct elt in initializers
  * Update builtins, tests and examples to use the new syntax
  * Bump to version 2.61

 -- Keith Packard <keithp@keithp.com>  Sun, 25 Nov 2007 21:57:24 -0800

nickle (2.60-1) unstable; urgency=low
  * Bump to version 2.60
  * Flush file output on exit call.
  * Extend Ctype namespace to latin-1.
  * Manage file buffer chains with explicit malloc/free.

 -- Keith Packard <keithp@keithp.com>  Tue, 02 Oct 2007 01:55:20 -0700

nickle (2.59-1) unstable; urgency=low
  * Bump to version 2.59
  * Have git ignore nickle binary
  * Clean up some autotools warnings
  * Make default rational display not include braces
  * Clean up some lintian warnings
  * Construct ChangeLog from git history for distribution.
  * No tail calls without a parent frame

 -- Keith Packard <keithp@keithp.com>  Sun, 23 Sep 2007 21:16:34 -0700

nickle (2.58-1) unstable; urgency=low
  * CCITT/ITU CRC-32 computation example
  * changed import PRNG to autoimport
  * get rid of archaic "v" print and scan functions
  * fixed signededness bug in integer carry calculation

 -- Keith Packard <keithp@keithp.com>  Thu, 26 Apr 2007 07:58:34 -0700

nickle (2.57-1) unstable; urgency=low
  * example/fourfours was using xor instead of exponentiation
  * De-macroize allocator.
  * Merge IntBinaryOperate into BinaryOperate.
  * PRNG is no longer loaded by default, tests need to load it.
  * Avoid broken GCC signed integer changes using -fwrapv.
  * Move version number to configure.in script and out of ChangeLog.

 -- Keith Packard <keithp@keithp.com>  Fri, 23 Mar 2007 12:10:39 -0700

nickle (2.56-1) unstable; urgency=low
  * Fix Catch object initialization order to avoid segfault

 -- Keith Packard <keithp@keithp.com>  Tue,  5 Dec 2006 12:57:06 -0800

nickle (2.55-1) unstable; urgency=low
  * Fix mismatching catch nesting depth in multi-peer try/catch
  * Add fourfours.5c example
  * Update debian-policy version to 3.7.2.1

 -- Keith Packard <keithp@keithp.com>  Tue,  5 Dec 2006 03:39:50 -0800

nickle (2.54-1) unstable; urgency=low
  * time() builtin needs to return all 32 bits
  * Update standards to 3.7.2
  * Compute NICKLELIBDIR at build time

 -- Keith Packard <keithp@keithp.com>  Sat, 20 May 2006 10:39:38 -0500

nickle (2.53-1) unstable; urgency=low
  * Use rpmbuild instead of rpm to build rpms (Keith Packard)
  * Permit {} in numbers to allow exact rational input
    (Keith Packard)

 -- Bart Massey <bart@cs.pdx.edu>  Sat,  28 Jan 2006 12:05:26 -0800

nickle (2.52-1) unstable; urgency=low
  * Add needed autoloads/autoimports to fix
    bugs introduced in examples, library (Bart Massey)

 -- Bart Massey <bart@cs.pdx.edu>  Sat,  11 Dec 2005 23:05:49 -0800

nickle (2.51-1) unstable; urgency=low
  * Don't load every random library; make the user autoload or
    autoimport them if they want them instead (Bart Massey)
  * Fixed bug introduced in copy function (Bart Massey)
  * Added &&= and ||= operators (Bart Massey)

 -- Bart Massey <bart@cs.pdx.edu>  Fri,  10 Dec 2005 14:11:45 -0800

nickle (2.50-1) unstable; urgency=low
  * Solaris build fixes (Bart Massey)
  * Various argument parsing buglets, including mis-parsing single character
    options (Bart Massey)
  * Permit any numeric type to TypeBinaryIntegral as required by
    unified numeric types. Representation errors will be caught by
    runtime system (Keith Packard)
  * Add system() popen() and run_process() (Bart Massey)
  * cbrt must use more intermediate precision to hit the
    specified error bound (Keith Packard)

 -- Keith Packard <keithp@keithp.com>  Tue,  6 Dec 2005 20:25:02 -0800

nickle (2.49-1) unstable; urgency=low
  * Fix &foo() return type to be pointer rather than reference.
  * Always set SO_BROADCAST for UDP sockets
  * Rewrite parse-args module to be more useful (Bart Massey)
  * Replace ad-hoc argument parsing code with parse-args (Bart Massey)

 -- Keith Packard <keithp@keithp.com>  Tue,  2 Aug 2005 23:10:30 -0700

nickle (2.48-1) unstable; urgency=low
  * Reference valued functions assigned to references need to avoid copy
  * avoid use of 'long long' type in rational.c, use 'signed_digit' instead
  * add 'π' as an alias for pi.

 -- Keith Packard <keithp@keithp.com>  Thu, 16 Jun 2005 13:53:06 -0700

nickle (2.47-1) unstable; urgency=low
  * Make builtin functions return pointers instead of references.
  * Check for NULL hash value in a valid hash element.
  * Initialize base.func pointer to NULL (Eric Anholt)
  * Functions returning reference type need to auto-dereference on return

 -- Keith Packard <keithp@keithp.com>  Tue, 15 Mar 2005 11:29:22 -0800

nickle (2.46-1) unstable; urgency=low
  * Fix error state confusion about nl handling
  * Make File builtins use error_type typedef instead of the union directly
  * Fix DoublePart to survive invalid value representations

 -- Keith Packard <keithp@keithp.com>  Thu, 13 Jan 2005 21:46:26 -0800

nickle (2.45-1) unstable; urgency=low
  * Add foreign function interface
  * Fix floating point printing a bit

 -- Keith Packard <keithp@keithp.com>  Fri, 24 Dec 2004 01:02:01 -0800

nickle (2.44-1) unstable; urgency=low
  * Add copyrights and eliminate non-DFSG examples.   Closes: 275277.
  * Fix seg fault when copying large stacks
  * Replace natural and string hash function with crc32
  * Make compatible with automake 1.9
  * Fix several minor resizable array bugs

 -- Keith Packard <keithp@keithp.com>  Wed,  1 Dec 2004 20:28:17 -0800

nickle (2.43-1) unstable; urgency=low
  * rewrite garbage collector to use simpler data structures

 -- Keith Packard <keithp@keithp.com>  Thu, 12 Aug 2004 21:21:28 -0700

nickle (2.42-1) unstable; urgency=low
  * unlimit stack to avoid crashes in recursive GC marking
  * add skiplists as an example
  * fix precedence of ** so that ++x**2 works
  * fix crash in HashEqual
  * fix minor newline tracking bug in lexer
  * add do_make_uninit (Bart Massey)
  * fix nasty allocator crash with continuations
  * fix handling of parallel catch blocks
  * fix tail call to longjmp

 -- Keith Packard <keithp@keithp.com>  Wed,  4 Aug 2004 11:30:08 -0700

nickle (2.41-1) unstable; urgency=low
  * Make a few grammar tweaks to improve NL handling
  * Fix crash with empty array/hash initializers
  * Add doc string support -- a comment following a function
    or exception.
  * Eliminate visible uses of nasty implicit unions.
  * Accept ** and && as unary operators
  * Fix some uses of & in lvalues

 -- Keith Packard <keithp@keithp.com>  Thu, 17 Jun 2004 17:02:13 -0700

nickle (2.38-1) unstable; urgency=low
  * fix manual to include correct version and date

 -- Keith Packard <keithp@keithp.com>  Thu, 27 May 2004 23:40:13 -0700

nickle (2.37-1) unstable; urgency=low
  * Negative left shifts gave off-by-one often (need ceil, not round)
  * 30-bit integer add/subtract overflow detection broken.

 -- Keith Packard <keithp@keithp.com>  Thu, 27 May 2004 22:58:14 -0700

nickle (2.36-1) unstable; urgency=low
  * distinguish between array types of static variables and
    initializers within static scope -- dimension storage is different

 -- Keith Packard <keithp@keithp.com>  Wed, 26 May 2004 01:50:58 -0700

nickle (2.35-1) unstable; urgency=low
  * new string parsing functions added
  * fix substr to allow zero-length at end of string
  * Change strings to counted to allow embedded nulls
  * fix profile tracking code (was generating garbage)
  * fix 'make check' to actually fail on error
  * Add argument parser library
  * Permit for (a; b) to skip initializer
  * Compute type of & expressions correctly
  * Allow &rvalue and have it automatically box the value

 -- Keith Packard <keithp@keithp.com>  Tue, 25 May 2004 20:32:09 -0700

nickle (2.31-1) unstable; urgency=low
  * Change resizable array representation to handle shrinking
  * Make File::end peek to check

 -- Keith Packard <keithp@keithp.com>  Thu, 15 Apr 2004 22:57:54 -0700

nickle (2.30-1) unstable; urgency=low
  * Document hashes
  * Add unresizable arrays and new resizable array type syntax
  * Fix a couple of multi-dimensional array dim ordering bugs
  * Add default hash table values
  * Oops.  Poly couldn't be a ref

 -- Keith Packard <keithp@keithp.com>  Sat, 10 Apr 2004 23:45:56 -0700

nickle (2.29-1) unstable; urgency=low

  * Add casts to avoid warnings where sizeof (int) != sizeof (void *)
  * Catch File::open_error when loading files and print
    reasonable message.   Closes: #241417.
  * exit(1) immediately if an file or library from the
    command line fails load.

 -- Keith Packard <keithp@keithp.com>  Thu,  1 Apr 2004 11:52:51 -0800

nickle (2.28-2) unstable; urgency=low

  * Separate build dependencies with commas

 -- Keith Packard <keithp@keithp.com>  Tue,  2 Mar 2004 19:08:52 -0800

nickle (2.28-1) unstable; urgency=low

  * Add ilog function (Bart Massey)

 -- Keith Packard <keithp@keithp.com>  Thu, 26 Feb 2004 21:15:05 -0800

nickle (2.27-1) unstable; urgency=low

  * Original debian packaging exporting version 2.27.

 -- Keith Packard <keithp@keithp.com>  Sun, 15 Feb 2004 13:56:38 -0800
